unit Find;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, BELib, IniFiles;

type
  TfrmFind = class(TForm)
    cmbFindText: TComboBox;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    chkIgnoreCase: TCheckBox;
    chkFromTop: TCheckBox;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure IniLoad;
    procedure IniSave;
  public
    { Public 錾 }
  end;

var
  frmFind: TfrmFind;

implementation

uses Main;

{$R *.DFM}

procedure TfrmFind.FormCreate(Sender: TObject);
begin
  MoveMainFormCenter(Self, frmMain);
  IniLoad;
end;

procedure TfrmFind.Button1Click(Sender: TObject);
var
  SText: String;
  Rc: Longint;
  i: Integer;
begin
  LockForm(frmMain);
  try
    SText := cmbFindText.Text;
    if SText = '' then
    begin
      ModalResult := mrNone;
      Exit;
    end;

    cmbFindText.Items.Insert(0, SText);
    for i := cmbFindText.Items.Count - 1 downto 1 do
      if cmbFindText.Items[i] = SText then
        cmbFindText.Items.Delete(i);

    while cmbFindText.Items.Count > 16 do
      cmbFindText.Items.Delete(cmbFindText.Items.Count - 1);

    frmMain.MxBinEditor1.SetSearchOptions(SText, chkIgnoreCase.Checked, False);
    Rc := frmMain.MxBinEditor1.Find(SText, chkIgnoreCase.Checked, TButton(Sender).Tag = 1, chkFromTop.Checked, True);

    Hide;
    if Rc = -1 then
      MsgBox(SText + ' ͌܂łB', MB_ICONINFORMATION);

    IniSave;
  finally
    UnLockForm(frmMain);
  end;

end;

procedure TfrmFind.IniLoad;
var
  Ini: TIniFile;
  Sec: String;
  i: Integer;
  SL: TStringList;
begin
  Ini := TIniFile.Create(AppPath + IniName);
  try
    Sec := 'Find';
    chkFromTop.Checked     := Ini.ReadBool(Sec, 'FromTop', False);

    Sec := 'FindStrings';

    SL := TStringList.Create;
    try
      Ini.ReadSectionValues(Sec, SL);
      for i := 0 to SL.Count - 1 do
        cmbFindText.Items.Append(SL.Values[IntToHex(i, 1)]);
    finally
      SL.Free;
    end;
    cmbFindText.ItemIndex := 0;
 
  finally
    Ini.Free;
  end;
end;

procedure TfrmFind.IniSave;
var
  Ini: TIniFile;
  Sec: String;
  i: Integer;
begin
  Ini := TIniFile.Create(AppPath + IniName);
  try
    Sec := 'Find';
    Ini.WriteBool(Sec, 'FromTop', chkFromTop.Checked);

    Sec := 'FindStrings';
    for i := 0 to cmbFindText.Items.Count - 1 do
      Ini.WriteString(Sec, IntToHex(i, 1), '"' + cmbFindText.Items[i] + '"');


  finally
    Ini.Free;
  end;
end;

end.
